{% extends "base.html" %}
{% block title %}
Setup CI project {{ repo_name }}
{% endblock %}

{% block content %}
<form class="was-validated" action="setup_ci" method="POST">
    <div class="row py-2">
        <div class="form-group col-md-6">
            <label for="repository_id">Repository ID: </label>
            <input type="text" name="repository_id" id="repository_id" value="{{ repo_id }}" class="form-control-plaintext fw-bold" readonly>
        </div>
        <div class="form-group col-md-6">
            <label for="repo_url">Repository URL:</label>
            <input type="text" name="repo_url" id="repo_url" value="{{ repo_url }}" class="form-control-plaintext fw-bold" readonly>
        </div>
    </div>
    {% if repo_webhook_setup %}
    <div class="row py-2">
        <div class="form-group col-md-12">
            <button class="btn btn-primary" type="button" data-bs-toggle="collapse" data-bs-target="#webhook_setup_details" aria-expanded="false" aria-controls="webhook_setup_details">
                Webhook setup details
            </button>
            <div class="collapse" id="webhook_setup_details">
                <div class="card card-body">
                    <p>Go to <a href="{{repo_webhook_url}}" target="_blank" rel="noopener noreferrer">{{repo_webhook_url}}</a> and add a new webhook</p>
                    <pre><code>{{repo_webhook_setup}}</code></pre>
                </div>
            </div>
        </div>
    </div>
    {% endif %}
    <div class="accordion" id="accordionConfigs">
        <div class="accordion-item">
            <h2 class="accordion-header" id="headerGlobal">
                <button class="accordion-button" type="button" data-bs-toggle="collapse" data-bs-target="#collapseGlobal" aria-expanded="true" aria-controls="collapseGlobal">
                    <strong>Global config</strong>
                </button>
            </h2>
            <div id="collapseGlobal" class="accordion-collapse collapse show" aria-labelledby="headingGlobal" data-bs-parent="#accordionConfigs">
                <div class="accordion-body">
                    <div class="form-group py-2">
                        <label for="name">Repository name:</label>
                        <input type="text" name="name" id="name" value="{{ repo_name }}" class="form-control" required>
                    </div>
                    <div class="form-check py-2">
                        <label class="form-check-label" for="privaterepo" data-bs-toggle="collapse" data-bs-target="#collapsePrivateRepoPublicSshKey"><input type="checkbox" class="form-check-input" value="true" name="privaterepo" id="privaterepo" {{ "checked" if is_private else "" }}> Private repository</label>
                        <small id="privaterepoHelp" class="form-text text-muted">Make the mirror a private repository (this implies that log files cannot be viewed in gitlab directly, there is a simpler interface to view log files)</small>
                        <div class="collapse{{" show" if is_private else ""}}" id="collapsePrivateRepoPublicSshKey">
                            <div class="card card-body">
                                <p>Your personal SSH deploy key is: <code>{{ssh_key_public}}</code></p>
                                {% if repo_provider == "github" %}
                                <p>Add this deploy key to <a href="{{repo_url}}/settings/keys" target="_blank" rel="noopener noreferrer">your repo here</a></p>
                                {% elif repo_provider == "bitbucket" %}
                                <p>Add this deploy key to <a href="{{repo_url}}/admin/access-keys/" target="_blank" rel="noopener noreferrer">your repo here</a></p>
                                {% else %}
                                <p>Unfortunately no documentation how to add your SSH deploy key</p>
                                {% endif %}
                                <p><strong>It is required to add this key such that the source code can be cloned on the target machines. It is <em>not</em> necessary to grant write acces to this deploy key.</strong></p>
                            </div>
                        </div>
                    </div>
                    <div class="form-group py-2">
                        <details>
                            <summary><label for="notification_token">Notification token:</label></summary>
                            {% if repo_provider == "github" %}
                            <p>Github's documentation on personal access tokens can be found at <a href="https://docs.github.com/en/authentication/keeping-your-account-and-data-secure/creating-a-personal-access-token" target="_blank" rel="noopener noreferrer">https://docs.github.com/en/authentication/keeping-your-account-and-data-secure/creating-a-personal-access-token</a>. Following this documentation create a token with scope <code>repo:status</code>. The personal access token is your notification token.</p>
                            {% elif repo_provider == "bitbucket" %}
                            <p>Bitbucket's documentation on App Passwords can be found at <a href="https://support.atlassian.com/bitbucket-cloud/docs/app-passwords/" target="_blank" rel="noopener noreferrer">https://support.atlassian.com/bitbucket-cloud/docs/app-passwords/</a>. Following this documentation create an app password with permission <code>Repository:Read</code>. Once you have created the app password, the notification token is <code>USERNAME:APP_PASSWORD</code>. Please note that USERNAME cannot be your email address, it must be your bitbucket username</p>
                            {% else %}
                            <p>Unfortunately no documentation how to create a notification token yet</p>
                            {% endif %}
                            <p><strong>The notification token is needed to report the build status back to your git repository.</strong></p>
                        </details>
                        <input type="text" name="notification_token" id="notification_token" value="" placeholder="***" class="form-control">
                        <small id="notificationTokenHelp" class="form-text text-muted">Current value is not echoed, leave it empty to keep it unchanged.</small>
                    </div>
                    <div class="form-group py-2">
                        <label for="webhook_secret">Webhook secret:</label>
                        <input type="text" name="webhook_secret" id="webhook_secret" value="" placeholder="***" class="form-control">
                        <small id="notificationTokenHelp" class="form-text text-muted">Current value is not echoed, leave it empty to keep it unchanged (keep in mind that the password to this setup site is the webhook secret)</small>
                    </div>
                    <div class="form-group py-2">
                        <details>
                            <summary><label for="whitelist_user">Default whitelisted users:</label></summary>
                            <p>Users who create a fork of your repository and then create a PR in your repository towards a CI enabled branch must be explicitly whitelisted. A PR that is not from a whitelisted user can be manually triggered by adding the comment <code>cscs-ci run</code> to the PR.</p>
                        </details>
                        <input type="text" name="whitelist_user" id="whitelist_user" value="{{ whitelist_user }}" class="form-control">
                        <small id="whitelistUserHelp" class="form-text text-muted">Comma-separated list of whitelisted users (applies to all pipelines, unless explicitly set to a different value in the pipeline config)</small>
                    </div>
                    <div class="form-group py-2">
                        <details>
                            <summary><label for="ci_branches">Default CI enabled branches:</label></summary>
                            <p>If this list is empty, then CI will never trigger automatically on a push event. To run CI you can create a PR and add a comment with the text <code>cscs-ci run</code>. This will trigger all pipelines manually.</p>
                        </details>
                        <input type="text" name="ci_branches" id="ci_branches" value="{{ ci_branches }}" class="form-control">
                        <small id="ciBranchesHelp" class="form-text text-muted">Comma-separated list of branch names for which CI will run on each push event (applies to all pipelines, unless explicitly set to a different value in the pipeline config)</small>
                    </div>
                </div>
            </div>
        </div>
        {% for pipeline in pipelines %}
        <div class="accordion-item">
            <h2 class="accordion-header" id="headerPipeline{{ pipeline["id"] }}">
                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#collapsePipeline{{ pipeline["id"] }}" aria-expanded="false" aria-controls="collapsePipeline{{ pipeline["id"] }}">
                    <strong>Pipeline {{ pipeline["name"] }}</strong>
                </button>
            </h2>
            <div id="collapsePipeline{{ pipeline["id"] }}" class="accordion-collapse collapse" aria-labelledby="headingPipeline{{ pipeline["id"] }}" data-bs-parent="#accordionConfigs">
                <div class="accordion-body">
                    <div class="form-group py-2">
                        <label for="{{ pipeline["id"] }}_name">Pipeline name:</label>
                        <input type="text" name="{{ pipeline["id"] }}_name" id="{{ pipeline["id"] }}_name" value="{{ pipeline["name"] }}" pattern="[A-Za-z0-9-]+" class="form-control">
                        <small class="form-text text-muted">Keep it short (e.g. P100, A100, GPU...). It will be used as name in the status notifications (alphanumeric characters or dash allowed, no whitespace)</small>
                    </div>
                    <div class="form-group py-2">
                        <label for="{{ pipeline["id"] }}_entrypoint">Pipeline YML-entrypoint:</label>
                        <input type="text" name="{{ pipeline["id"] }}_entrypoint" id="{{ pipeline["id"] }}_entrypoint" value="{{ pipeline["ci_entrypoint"] }}" class="form-control">
                        <small class="form-text text-muted">Relative path to yml file in the repository</small>
                    </div>
                    <div class="form-group py-2">
                        <label for="{{ pipeline["id"] }}_whitelist_user">Whitelisted users:</label>
                        <input type="text" name="{{ pipeline["id"] }}_whitelist_user" id="{{ pipeline["id"] }}_whitelist_user" value="{{ pipeline["whitelist_user"] }}" class="form-control">
                        <small class="form-text text-muted">Comma-separated list of whitelisted users (overrides default config if not empty)</small>
                    </div>
                    <div class="form-group py-2">
                        <label for="{{ pipeline["id"] }}_ci_branches">CI enabled branches:</label>
                        <input type="text" name="{{ pipeline["id"] }}_ci_branches" id="{{ pipeline["id"] }}_ci_branches" value="{{ pipeline["ci_branches"] }}" class="form-control">
                        <small class="form-text text-muted">Comma-separated list of branch names for which CI will run on each push event (overrides default config if not empty)</small>
                    </div>
                    <div class="form-check py-2">
                        <label class="form-check-label" for="{{ pipeline["id"] }}_trigger_pr">
                            <input type="checkbox" class="form-check-input" value="true" name="{{ pipeline["id"] }}_trigger_pr" id="{{ pipeline["id"] }}_trigger_pr" {{ "checked" if pipeline["trigger_pr"] else "" }}> Trigger PR's targeting CI enabled branches automatically
                        </label>
                    </div>
                    {% if loop.length > 1 %}
                    <a href="pipeline_delete/{{ pipeline["id"] }}">
                        <button type="button" class="btn btn-danger">
                            <svg class="bi" height="1em" width="1em" fill="currentColor">
                                <use xlink:href="static/img/bootstrap-icons.svg#x-circle" />
                            </svg>
                            Delete pipeline {{ pipeline["name"] }}
                        </button>
                    </a>
                    {% endif %}
                </div>
            </div>
        </div>
        {% endfor %}
    </div>
    <button type="submit" class="btn btn-primary">Submit changes</button>
    <a href="pipeline_create/{{repo_id}}">
        <button type="button" class="btn btn-secondary">Add new pipeline</button>
    </a>
</form></div>

<a href="setup_ci_relogin" style="position: absolute; right: 10px; top: 10px">Login for another project</a>

<script>
    document.addEventListener('readystatechange', event => {
        if ({{selected_pipeline}} != -1) {
            bootstrap.Collapse.getOrCreateInstance(document.getElementById("collapsePipeline{{selected_pipeline}}")).toggle();
        }
    });
</script>


{% endblock %}
